---
title: Grid wrapper
slug: Web/CSS/Layout_cookbook/Grid_wrapper
tags:
  - CSS
  - Guide
  - Layout
  - cookbook
  - recipes
---
<div>{{CSSRef}}</div>

<p class="summary">The grid wrapper pattern is useful for aligning grid content within a central wrapper, while also allowing items to break out and align to the edge of the containing element or page when desired.</p>

<h2 id="Requirements">Requirements</h2>

<p>Items placed on the grid should be able to align to a horizontally-centered max-width wrapper and/or the outer edges of the grid.</p>

<h2 id="Recipe">Recipe</h2>

<p>{{EmbedGHLiveSample("css-examples/css-cookbook/grid-wrapper.html", '100%', 720)}}</p>

<div class="note">
<p><a href="https://github.com/mdn/css-examples/blob/master/css-cookbook/grid-wrapper--download.html">Download this example</a></p>
</div>

<h2 id="Choices_made">Choices made</h2>

<p id="docs-internal-guid-30ae4ecd-7fff-36c2-da7d-0fbb6ec4feae">This recipe uses the CSS Grid {{cssxref("minmax()")}} function to define the grid track sizes in the {{cssxref("grid-template-columns")}} property. For the central columns with a maximum width we can set a minimum value of 0 or greater and a maximum value that specifies the maximum size the column tracks will grow to. Using a numeric unit (pixels, ems, rems) will create a fixed maximum size for the central wrapper, whereas using percentage values or viewport units will mean this wrapper grows or shrinks in response to its context.</p>

<p>The outer two columns have a maximum size of <code>1fr</code>, meaning that they will each expand to fill the remaining available space in the grid container.</p>

<h2 id="Useful_fallbacks_or_alternative_methods">Useful fallbacks or alternative methods</h2>

<p>When using this recipe at page level it can be useful to set a <code>max-width</code> along with left and right <code>auto</code> {{cssxref("margin")}}s to center the content horizontally:</p>

<pre class="brush: css">.grid {
  max-width: 1200px;
  margin: 0 auto; // horizontally centers the container
}

/* Remove the max-width and margins if the browser supports Grid */
@supports (display: grid) {
  .grid {
    display: grid;
    /* Other grid code goes here */
    max-width: none;
    margin: 0;
  }
}</pre>

<p>To “break out” a full-width item to the edge of the viewport you can then use this trick (courtesy of <a href="https://una.im/">Una Kravets</a>):</p>

<pre class="brush: css">.item {
  width: 100vw;
  margin-left: 50%;
  transform: translate3d(-50%, 0, 0);
}</pre>

<p>This gives a good approximation of the layout, only without the benefit of being able to align items easily on an exact grid.</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Although Grid enables us to position items anwhere (within reason), it is important when placing items using CSS Grid that your underlying markup follows a logical order (see <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid_Layout_and_Accessibility">CSS Grid layout and accessibility</a> for more details).</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>The various layout methods have different browser support. See the charts below for details on basic support for the properties used.</p>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<h4 id="grid-template-columns">grid-template-columns</h4>

<p>{{Compat("css.properties.grid-template-columns")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{Cssxref("grid-template-columns")}}</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout" id="docs-internal-guid-ae8eafc9-7fff-65b9-8d8c-bb5f1e3c874c">CSS Grid Layout on MDN</a></li>
 <li>Article:<a href="https://css-irl.info/more-flexibility-with-minmax/"> CSS Grid: More flexibility with minmax()</a></li>
 <li>Article: <a href="https://rachelandrew.co.uk/archives/2017/06/01/breaking-out-with-css-grid-explained/">Breaking Out with CSS Grid</a></li>
</ul>
